/* Esta produccion tiene licencia GPL (www.gnu.org) */

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include <stdio.h>
#include <stdlib.h>

float rotX = -50.0f, rotY = 0.0f, rotZ = 0.0f;
float posX = 0.0f, posY = 0.0f, posZ = 0.0f;

void Landoescapio()
{

}

void InicializarGL()
{
  glFrontFace(GL_CCW);
  glEnable(GL_CULL_FACE);
  glEnable(GL_DEPTH_TEST);

  float Gris [] = { 0.5f, 0.5f, 0.5f, 1.0f };
  glEnable(GL_LIGHTING);
  glLightfv(GL_LIGHT0, GL_AMBIENT, Gris);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, Gris);
  glLightfv(GL_LIGHT0, GL_POSITION, Gris);
  glEnable(GL_LIGHT0);

  float Marron [] = { 0.7f, 0.5f, 0.0f, 1.0f };
  glEnable(GL_COLOR_MATERIAL);
  glColorMaterial(GL_FRONT, GL_AMBIENT_AND_DIFFUSE);
  glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, Marron);

  glEnable (GL_FOG);
  glFogfv (GL_FOG_COLOR, Gris);
  glFogf (GL_FOG_DENSITY, 0.001);

  glClearColor (0.0f,0.0f,0.8f,1.0f);
}

void Renderizar()
{
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glTranslatef(-50.0f+posX, 0.0f+posY, -100.0f+posZ);
  glRotatef(rotX,1.0f,0.0f,0.0f);
  glRotatef(rotY,0.0f,1.0f,0.0f);
  glRotatef(rotZ,0.0f,0.0f,1.0f);

  glColor3f(0.5f, 0.5f, 0.0f);
  glBegin(GL_TRIANGLE_FAN);
  glVertex3f(300.0,125.0,0.0);
  glVertex3f(-300.0,125.0,0.0);
  glVertex3f(-300.0,-125.0,0.0);
  glVertex3f(300.0,-125.0,0.0);
  glEnd();

  glFlush();
  glutSwapBuffers();
}

void Resize (GLsizei w, GLsizei h)
{
  glViewport(0, 0, w, h);

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(60.0f, w/h, 1.0, 400.0);
}

void Idle()
{
  Renderizar();
}

void Teclado(unsigned char Tecla, int x, int y)
{
  switch (Tecla) {
    case 'w':
      rotX += 1.0f;
      break;
    case 's':
      rotX -= 1.0f;
      break;
    case 'a':
      rotZ += 1.0f;
      break;
    case 'd':
      rotZ -= 1.0f;
      break;
  }
}

int main(int argc, char *argv[])
{
  glutInit(&argc,argv);
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA);

  glutInitWindowSize(640,480);
  glutInitWindowPosition(100,100);
  glutCreateWindow("Landoescapio");

  glutDisplayFunc(Renderizar);
  glutIdleFunc(Idle);
  glutKeyboardFunc(Teclado);
  glutReshapeFunc(Resize);

  InicializarGL();
  Landoescapio();

  glutMainLoop();

  return 0;
}

